| IGLib 1.7.2 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events Macros
Properties | List of all members
IG.Num.IRealFunctionPenalty Interface Reference

Interface that must be satisfied by penalty functions. Penalty functions have small values where argument is less than 0, and grow fast where their argument is positive. More...

Inheritance diagram for IG.Num.IRealFunctionPenalty:
[legend]
Collaboration diagram for IG.Num.IRealFunctionPenalty:
[legend]

## Properties
bool | IsFiniteSupport`[get]`
| Whether penalty function has finite support (meaning that it is 0 for all arguments less than some specific value). More...
bool | IsAbsoluteDifferentiable`[get]`
| True if absolute value is differentiable, false otherwise. Differentiability of absolute value at 0 is important for penalty functions used for equality constraints. More...
bool | IsAbsoluteTwiceDifferentiable`[get]`
| True if absolute value is twoce differentiable, false otherwise. Differentiability of absolute value at 0 is important for penalty functions used for equality constraints. More...
bool | CanSetMaxZero`[get]`
| Whether maximal value for which penalty function is zero can be set. More...
bool | CanSetBarrierLength`[get]`
| Whether the gap can be set. More...
bool | CanSetBarrierHeight`[get]`
| Whether the height can be set. More...
double | MaxZero`[get, set]`
| Maximal value for which penalty function is zero. More...
double | BarrierLength`[get, set]`
| Gap - characteristic length of transition area on which penalty function grows for about (or sometimes exactly, especially in case of finite support) characteristic height. More...
double | BarrierHeight`[get, set]`
| Characteristic heitht of transition area, usually value of the penalty function at the end of transition area. More...
Properties inherited from IG.Num.IRealFunction
string | Name`[get]`
| Returns a short name of the function. More...
string | Description`[get]`
| Returns a short description of the function. More...
bool | ValueDefined`[get]`
| Tells whether value of the function is defined by implementation. More...
bool | DerivativeDefined`[get]`
| Tells whether the first derivative is defined for this function (by implementation, not mathematically) More...
bool | SecondDerivativeDefined`[get]`
| Tells whether the second derivative is defined for this function (by implementation, not mathematically) More...
bool | IntegralDefined`[get]`
| Tells whether analytical itegral of the function is defined or not. More...
bool | InverseDefined`[get]`
| Tells whether analytical inverse function is defined or not. More...

## Additional Inherited Members
Public Member Functions inherited from IG.Num.IRealFunction
double | Value (double x)
| Returns the value of this function at the specified parameter. More...
double | Derivative (double x)
| Returns the first derivative of this function at the specified parameter. More...
double | Derivative (double x, int order)
| Returns the derivative of the given order of this function at the specified parameter. More...
bool | HigherDerivativeDefined (int order)
| Tells whether the derivative of the given order is defined for this function (by implementation, not mathematically) More...
double | SecondDerivative (double x)
| Returns the second derivative of the given order of this function at the specified arameter. More...
double | Integral (double x)
| Returns integral from 0 to x of the function. Throws an exception if the integral is not defined. More...
double | Inverse (double y)
| Returns Inverse of the current function applied to function argument. Throws an exception if the inverse function is not defined. More...
void | Tabulate (double from, double to, int numPoints)
| Tabulates the current function and its first and second derivatives (when available) on the specified interval, in the specified number of points. More...
void | Tabulate (double from, double to, int numPoints, bool printDerivatives)
| Tabulates the current function and its first and eventually second derivatives (when available) on the specified interval, in the specified number of points. More...
void | Tabulate (double from, double to, int numPoints, bool printDerivatives, bool printSecondDerivatives)
| Tabulates the current function and eventually its first and second derivatives (when available) on the specified interval, in the specified number of points. More...
double | NumericalIntegral (double from, double to, int numintervals)
| Calculates numerical integral of this function. Simpson's formula is usually used. More...
double | NumericalDerivative (double x, double stepsize)
| Calculates numerical derivative of this function. Central difference formula is used. More...
double | NumericalSecondDerivative (double x, double stepsize)
| Calculates numerical second order derivative of this function. Central difference formula is used. More...

## Detailed Description

Interface that must be satisfied by penalty functions. Penalty functions have small values where argument is less than 0, and grow fast where their argument is positive.

$A Igor xx;

## Property Documentation

bool IG.Num.IRealFunctionPenalty.IsFiniteSupport
| get

Whether penalty function has finite support (meaning that it is 0 for all arguments less than some specific value).

bool IG.Num.IRealFunctionPenalty.IsAbsoluteDifferentiable
| get

True if absolute value is differentiable, false otherwise. Differentiability of absolute value at 0 is important for penalty functions used for equality constraints.

bool IG.Num.IRealFunctionPenalty.IsAbsoluteTwiceDifferentiable
| get

True if absolute value is twoce differentiable, false otherwise. Differentiability of absolute value at 0 is important for penalty functions used for equality constraints.

bool IG.Num.IRealFunctionPenalty.CanSetMaxZero
| get

Whether maximal value for which penalty function is zero can be set.

Referenced by IG.Num.PenaltyEvaluator.CanSetMaxZero(), and IG.Num.PenaltyEvaluator.SetPenaltyFunction().

bool IG.Num.IRealFunctionPenalty.CanSetBarrierLength
| get

Whether the gap can be set.

Referenced by IG.Num.PenaltyEvaluator.CanSetBarrierLength(), and IG.Num.PenaltyEvaluator.SetPenaltyFunction().

bool IG.Num.IRealFunctionPenalty.CanSetBarrierHeight
| get

Whether the height can be set.

Referenced by IG.Num.PenaltyEvaluator.CansetBarrierHeight(), and IG.Num.PenaltyEvaluator.SetPenaltyFunction().

double IG.Num.IRealFunctionPenalty.MaxZero
| get set

Maximal value for which penalty function is zero.

Referenced by IG.Num.PenaltyEvaluator.SetPenaltyFunction().

double IG.Num.IRealFunctionPenalty.BarrierLength
| get set

Gap - characteristic length of transition area on which penalty function grows for about (or sometimes exactly, especially in case of finite support) characteristic height.

Referenced by IG.Num.PenaltyEvaluator.SetPenaltyFunction().

double IG.Num.IRealFunctionPenalty.BarrierHeight
| get set

Characteristic heitht of transition area, usually value of the penalty function at the end of transition area.

Referenced by IG.Num.PenaltyEvaluator.SetPenaltyFunction().

The documentation for this interface was generated from the following file:

- igbase/numeric/FunctionRealPenalty.cs